//
// Created by BONNe
// Copyright - 2020
//


package world.bentobox.challenges.utils;


/**
 * This class contains String constants used in messages and guis.
 */
public class Constants
{
    /**
     * Reference string to ADDON_NAME in translations.
     */
    public static final String ADDON_NAME = "challenges.";

// ---------------------------------------------------------------------
// Section: Commands
// ---------------------------------------------------------------------


    /**
     * Reference string to Commands in translations.
     */
    public static final String COMMANDS = ADDON_NAME + "commands.";

    /**
     * Reference string to Admin in translations.
     */
    public static final String ADMIN_COMMANDS = COMMANDS + "admin.";

    /**
     * Reference string to Player in translations.
     */
    public static final String PLAYER_COMMANDS = COMMANDS + "player.";

// ---------------------------------------------------------------------
// Section: GUI
// ---------------------------------------------------------------------

    /**
     * Reference string to GUI in translations.
     */
    public static final String GUI = ADDON_NAME + "gui.";

    /**
     * Reference string to TITLE in translations.
     */
    public static final String TITLE = GUI + "titles.";

    /**
     * Reference string to BUTTON in translations.
     */
    public static final String BUTTON = GUI + "buttons.";

    /**
     * Reference string to TIPS in translations.
     */
    public static final String TIPS = GUI + "tips.";

    /**
     * Reference string to DESCRIPTION in translations.
     */
    public static final String DESCRIPTIONS = GUI + "descriptions.";

    /**
     * Reference string to Messages in translations.
     */
    public static final String MESSAGES = ADDON_NAME + "messages.";

    /**
     * Reference string to Errors in translations.
     */
    public static final String ERRORS = ADDON_NAME + "errors.";

    /**
     * Reference string to Questions in translations.
     */
    public static final String CONVERSATIONS = ADDON_NAME + "conversations.";

// ---------------------------------------------------------------------
// Section: Other
// ---------------------------------------------------------------------

    /**
     * Reference string to materials in translations.
     */
    public static final String MATERIALS = ADDON_NAME + "materials.";

    /**
     * Reference string to entities in translations.
     */
    public static final String ENTITIES = ADDON_NAME + "entities.";

    /**
     * Reference string to environments in translations.
     */
    public static final String ENVIRONMENTS = ADDON_NAME + "environments.";

    /**
     * Reference string to statistics in translations.
     */
    public static final String STATISTICS = ADDON_NAME + "statistics.";

    /**
     * Reference string to item stacks in translations.
     */
    public static final String ITEM_STACKS = ADDON_NAME + "item-stacks.";

// ---------------------------------------------------------------------
// Section: Parameters
// ---------------------------------------------------------------------

    /**
     * Reference string to gamemode parameter in translations.
     */
    public static final String PARAMETER_GAMEMODE = "[gamemode]";

    /**
     * Reference string to world parameter in translations.
     */
    public static final String PARAMETER_WORLD = "[world]";

    /**
     * Reference string to value parameter in translations.
     */
    public static final String PARAMETER_VALUE = "[value]";

    /**
     * Reference string to block parameter in translations.
     */
    public static final String PARAMETER_MATERIAL = "[material]";

    /**
     * Reference string to entity parameter in translations.
     */
    public static final String PARAMETER_ENTITY = "[entity]";

    /**
     * Reference string to environment parameter in translations.
     */
    public static final String PARAMETER_ENVIRONMENT = "[environment]";
    
    /**
     * Reference string to file parameter in translations.
     */
    public static final String PARAMETER_FILE = "[file]";

    /**
     * Reference string to id parameter in translations.
     */
    public static final String PARAMETER_ID = "[id]";

    /**
     * Reference string to min parameter in translations.
     */
    public static final String PARAMETER_MIN = "[min]";

    /**
     * Reference string to max parameter in translations.
     */
    public static final String PARAMETER_MAX = "[max]";

    /**
     * Reference to an author parameter in translation.
     */
    public static final String PARAMETER_AUTHOR = "[author]";

    /**
     * Reference to an lang parameter in translation.
     */
    public static final String PARAMETER_LANG = "[lang]";

    /**
     * Reference to an version parameter in translation.
     */
    public static final String PARAMETER_VERSION = "[version]";

    /**
     * Reference to island in translations.
     */
    public static final String PARAMETER_ISLAND = "[island]";

    /**
     * Reference string to number parameter in translations.
     */
    public static final String PARAMETER_NUMBER = "[number]";

    /**
     * Reference string to permission parameter in translations.
     */
    public static final String PARAMETER_PERMISSION = "[permission]";

    /**
     * Reference string to player parameter in translations.
     */
    public static final String PARAMETER_PLAYER = "[player]";

    /**
     * Reference string to owner parameter in translations.
     */
    public static final String PARAMETER_OWNER = "[owner]";

    /**
     * Reference string to name parameter in translations.
     */
    public static final String PARAMETER_NAME = "[name]";

    /**
     * Reference string to level parameter in translations.
     */
    public static final String PARAMETER_LEVEL = "[level]";
    
    /**
     * Reference string to description parameter in translations.
     */
    public static final String PARAMETER_DESCRIPTION = "[description]";

    /**
     * Reference string to challenge parameter in translations.
     */
    public static final String PARAMETER_CHALLENGE = "[challenge]";

    /**
     * Regex escape chars.
     */
    public static final String ESC = "\\";
}
